#include <bits/stdc++.h>
using namespace std;
int main()
{
    string s;
    cin>>s;
    long long d=s.length();
    bool w=true;
    for(int y=0;y<d/2;y++)
    {
        if(s[y]!=s[d-y-1]) w=false;
    }
    if(w) cout<<"1";
    else
    {
        int rez=s.length()-1;
        int LevaStrana[30]={0};
        int DesnaStrana[30]={0};
        string pomocni=s;
        int l=0;
        while(pomocni[0]==pomocni[d-1-2*l])
        {
            pomocni.erase(0,1);
            pomocni.pop_back();
            l++;
        }
        int c =pomocni.length();
        LevaStrana[pomocni[0]-'a']++;
        for(int i=1;i<c;i++)
        {
            DesnaStrana[pomocni[i]-'a']++;
        }
        for(int i=0;i<c;i++)
        {
            bool p=true;
            int Brojac=0;
            for(int j=0;j<30;j++)
            {
                if((LevaStrana[j]>DesnaStrana[j])&&((LevaStrana[j]!=1)||(DesnaStrana[j]!=0))) p=false;
                else
                {
                    DesnaStrana[j]-=LevaStrana[j];
                    if(abs(DesnaStrana[j])%2==1) Brojac++;
                    DesnaStrana[j]+=LevaStrana[j];
                }
            }
            if(p==true&&Brojac==1) rez=min(rez,c-i-1);
            LevaStrana[pomocni[i+1]-'a']++;
            DesnaStrana[pomocni[i+1]-'a']--;
        }
        LevaStrana[30]={0};
        DesnaStrana[30]={0};
        DesnaStrana[pomocni[c-1]-'a']++;
        for(int z=0;z<c-1;z++)
        {
            LevaStrana[pomocni[z]-'a']++;
        }
        for(int f=0;f<c;f++)
        {
            bool q=true;
            int Brojac1=0;
            for(int g=0;g<30;g++)
            {
                if((DesnaStrana[g]>LevaStrana[g])&&((DesnaStrana[g]!=1)||(LevaStrana[g]!=0))) q=false;
                else
                {
                    LevaStrana[g]-=DesnaStrana[g];
                    if(abs(LevaStrana[g])%2==1) Brojac1++;
                    LevaStrana[g]+=DesnaStrana[g];
                }
            }
            if(q==true&&Brojac1==1) rez=min(rez,c-f-1);
            LevaStrana[pomocni[c-f-2]-'a']--;
            DesnaStrana[pomocni[c-f-2]-'a']++;
        }
        cout<<rez;
    }
}